{{ sixteen_level_raised_cosine_cogged_16bit.spin }}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  propTX  = 30 'programming output
  propRX  = 31 'programming input
  baudrate = 115_200

OBJ
  Clock : "Clock"

VAR
  BYTE buffer[100] 'buffer to assemble output strings
    

PUB Main | i
  Clock.init (5_000_000) ' 6_144_000)
  Clock.setclock (XTAL1 + PLL16X) 'Set clock to really fast

  time := CNT + 800_000  ' 10ms
  cognum := -1
  cognew (@entry, 0)
  waitcnt (CNT + 10_000)

  i := 0
  repeat until i => 5
    cognum := i
    i += 1
    cognew (@entry, 0)
    waitcnt (CNT + 10_000)

  repeat
    waitcnt (CNT + 10_000_000)


DAT
                ORG     0

' raised cosine FIR filter tables, 5 samples per symbol, order 31 FIR
' 8 tables in the ratio 1 : 3 : 5 : 7 : 9 : 11 : 13 : 15,
' and the sign is flipped to make 16 equally spaced sets, scaled -15, -13, ..., -1, +1, +3, ..., +15
entry
coeff1_0        jmp     #real_entry
                long    35
                long    70
                long    86
                long    65
real_coeff1_0
coeff1_5        long    0
                long    -96
                long    -188
                long    -230
                long    -175
coeff1_10
                long    0
                long    286
                long    636
                long    975
                long    1220
coeff1_15
                long    1310
                long    1220
                long    975
                long    636
                long    286
coeff1_20
                long    0
                long    -175
                long    -230
                long    -188
                long    -96
coeff1_25
                long    0
                long    65
                long    86
                long    70
                long    35
coeff1_30
                long    0
                nop           ' pad each table to power of two
coeff3_0
                long    0
                long    104
                long    209
                long    257
                long    194
coeff3_5
                long    0
                long    -287
                long    -564
                long    -689
                long    -526
coeff3_10
                long    0
                long    859
                long    1909
                long    2924
                long    3660
coeff3_15
                long    3929
                long    3660
                long    2924
                long    1909
                long    859
coeff3_20
                long    0
                long    -526
                long    -689
                long    -564
                long    -287
coeff3_25
                long    0
                long    194
                long    257
                long    209
                long    104
coeff3_30
                long    0
                nop
coeff5_0
                long    0
                long    173
                long    348
                long    429
                long    324
coeff5_5
                long    0
                long    -478
                long    -940
                long    -1149
                long    -877
coeff5_10
                long    0
                long    1432
                long    3182
                long    4874
                long    6100
coeff5_15
                long    6548
                long    6100
                long    4874
                long    3182
                long    1432
coeff5_20
                long    0
                long    -877
                long    -1149
                long    -940
                long    -478
coeff5_25
                long    0
                long    324
                long    429
                long    348
                long    173
coeff5_30
                long    0
                nop
coeff7_0
                long    0
                long    242
                long    487
                long    601
                long    454
coeff7_5
                long    0
                long    -670
                long    -1317
                long    -1608
                long    -1227
coeff7_10
                long    0
                long    2005
                long    4455
                long    6823
                long    8540
coeff7_15
                long    9167
                long    8540
                long    6823
                long    4455
                long    2005
coeff7_20
                long    0
                long    -1227
                long    -1608
                long    -1317
                long    -670
coeff7_25
                long    0
                long    454
                long    601
                long    487
                long    242
coeff7_30
                long    0
                nop
coeff9_0
                long    0
                long    311
                long    627
                long    772
                long    583
coeff9_5
                long    0
                long    -861
                long    -1693
                long    -2068
                long    -1578
coeff9_10
                long    0
                long    2578
                long    5728
                long    8773
                long    10980
coeff9_15
                long    11786
                long    10980
                long    8773
                long    5728
                long    2578
coeff9_20
                long    0
                long    -1578
                long    -2068
                long    -1693
                long    -861
coeff9_25
                long    0
                long    583
                long    772
                long    627
                long    311
coeff9_30
                long    0
                nop
coeff11_0
                long    0
                long    380
                long    766
                long    944
                long    713
coeff11_5
                long    0
                long    -1052
                long    -2069
                long    -2527
                long    -1929
coeff11_10
                long    0
                long    3151
                long    7001
                long    10723
                long    13420
coeff11_15
                long    14405
                long    13420
                long    10723
                long    7001
                long    3151
coeff11_20
                long    0
                long    -1929
                long    -2527
                long    -2069
                long    -1052
coeff11_25
                long    0
                long    713
                long    944
                long    766
                long    380
coeff11_30
                long    0
                nop
coeff13_0
                long    0
                long    449
                long    905
                long    1115
                long    843
coeff13_5
                long    0
                long    -1244
                long    -2445
                long    -2987
                long    -2279
coeff13_10
                long    0
                long    3724
                long    8274
                long    12672
                long    15860
coeff13_15
                long    17024
                long    15860
                long    12672
                long    8274
                long    3724
coeff13_20
                long    0
                long    -2279
                long    -2987
                long    -2445
                long    -1244
coeff13_25
                long    0
                long    843
                long    1115
                long    905
                long    449
coeff13_30
                long    0
                nop
coeff15_0
                long    0
                long    518
                long    1044
                long    1287
                long    972
coeff15_5
                long    0
                long    -1435
                long    -2821
                long    -3446
                long    -2630
coeff15_10
                long    0
                long    4297
                long    9546
                long    14622
                long    18300
coeff15_15
                long    19644
                long    18300
                long    14622
                long    9546
                long    4297
coeff15_20
                long    0
                long    -2630
                long    -3446
                long    -2821
                long    -1435
coeff15_25
                long    0
                long    972
                long    1287
                long    1044
                long    518
coeff15_30
                long    0
                nop


add_coeff1_inst add     t, coeff1_0   ' template instruction to use when updating on new bits

real_entry
		mov	coeff1_0, real_coeff1_0  ' repair table
		
                cmps    cognum, #0  wz,wc   ' cognum == -1 is the data generation cog, 0..4 for the FIR cogs
        if_b    jmp     #datagen
        
                ' set base index equal to cog number, so each is staggered to cover whole table
                add     add_coeff1_inst, cognum
                add     ins0, cognum
                add     ins1, cognum
                add     ins2, cognum
                add     ins3, cognum
                add     ins4, cognum
                add     ins5, cognum
                
                mov     t, cognum  ' 24 x cog number, since 6 instructions offset per cog
                shl     t, #2
                add     t, cognum
                add     t, cognum
                shl     t, #2

                mov     DIRA, output_pins  ' we drive 16 pins, to match the scale of values in coeff tables
                add     time, t 
                WAITCNT time, #0    ' sync for cog
                jmp     #entloop
		
loop                                ' loop is 30 instructions, with 5 cogs running, that's 6 instructions per output sample
                mov     t, H8000   
ins0            add     t, coeff1_0 ' sum the filter (each cog does a different set of interleaved coefficients)
ins1            add     t, coeff1_5
ins2            add     t, coeff1_10
ins3            add     t, coeff1_15
ins4            add     t, coeff1_20
ins5            add     t, coeff1_25
                mov     OUTA, t     ' output our sample
                mov     ins5, ins4      ' shift the instructions up for next time, so symbol moves along
                add     ins5, #5        ' offset has to increase by 5 each symbol
                mov     ins4, ins3
                add     ins4, #5
                mov     ins3, ins2
                mov     OUTA, #0    ' let other cogs control the pins
                add     ins3, #5
                mov     ins2, ins1
                add     ins2, #5
                mov     ins1, ins0
                add     ins1, #5
entloop
                mov     t, INA      ' read the databits from the datagen cog
		and	t, data_mag ' 3 bits for magnitude (select one of the 8 coefficient tables)
		shr	t, #16-5    ' shift to multiple of 32
		mov	ins0, add_coeff1_inst   ' construct the instruction
		add	ins0, t                 ' make it index the right table
                test    data_sign, INA  wc      ' flip from add to sub if sign bit zero
                muxnc   ins0, subbit
		nop                             ' pad loop to multiple of 5 since 5 cogs in lock-step
		nop
		nop
                jmp     #loop

' generate test bits - this cog could pull data from buffer, but here just a 32bit LFSR to generate flat spectrum
datagen         mov     DIRA, data_sign    ' the pins to send out the bits on
                or      DIRA, data_mag
	        neg     reg, #1            ' init LFSR reg
lfsr            test    reg, feedback  wc  ' drive LFSR 4 times for 4 bits to output
                rcr     reg, #1  wc
                muxc    t, databit0
                test    reg, feedback  wc
                rcr     reg, #1  wc
                muxc    t, databit1
                test    reg, feedback  wc
                rcr     reg, #1  wc
                muxc    t, databit2
                test    reg, feedback  wc
                rcr     reg, #1  wc
                muxc    t, data_sign
                WAITCNT time, #120         ' sync with FIR cogs
                mov     OUTA, t
                jmp     #lfsr


                

subbit          long    %000001_0000_0000_000000000_000000000 ' flips ADD to SUB instr.

output_pins     long    $0000ffff   ' 16 lowest pins to R-2R DAC (8 bits would be enough though I think)
data_sign       long    $00080000   ' LFSR generated databits use pins 16..19
databit0        long    $00010000
databit1        long    $00020000
databit2        long    $00040000
data_mag        long    $00070000
H8000           long    $8000       ' used to bias the output mid-scale rather than 2's complement

feedback        long    $b4bcd35c   ' maximal 32 bit LFSR polynomial


' parameters to the cog(s), set in spin
time            long    0
cognum          long    0

' other variables
t               res     1
reg             res     1


                FIT     $1F0
